#include <stdio.h>
#include <dlfcn.h>

int 
main (int argc, char *argv[])
{
  const char *dll = (argc >= 2) ? argv[1] : "dll-example.dll";
  void *dll_handle;
  typedef int (*ifp) (int);
  ifp funcp;
  int value;
  typedef double (*ffp) (double);
  ffp ffuncp;
  double fvalue;

  dll_handle = dlopen (dll, RTLD_LAZY | RTLD_GLOBAL);
  if (! dll_handle)
    {
      printf ("%s\n", dlerror ());
      exit (1);
    }
  
  funcp = (ifp) dlsym (dll_handle, "dll_func_int");
  if (! funcp)
    {
      printf ("%s\n", dlerror ());
      exit (1);
    }
  
  printf ("Calling `%s' from shared object `%s'...\n", "dll_func_int", dll);
  value = (*funcp) (3);
  printf ("return value: %d\n", value);

  ffuncp = (ffp) dlsym (dll_handle, "dll_func_double");
  if (! ffuncp)
    {
      printf ("%s\n", dlerror ());
      exit (1);
    }
  
  printf ("Calling `%s' from shared object `%s'...\n", "dll_func_double", dll);
  fvalue = (*ffuncp) (3.0);
  printf ("return value: %f\n", fvalue);

  exit (0);
}

